scoreboard players reset @s starttimer
gamemode adventure @a
clear @a
scoreboard players set @a playerID 0
scoreboard players reset @a[tag=spectate] playerID
tp @a[tag=spectate] 0 60 90
scoreboard players set @s blocks 0

tag @a[tag=!spectate] add player

scoreboard players set @a[tag=!spectate,limit=1,sort=random,scores={playerID=0}] playerID 1
scoreboard players set @a[tag=!spectate,limit=1,sort=random,scores={playerID=0}] playerID 2
scoreboard players set @a[tag=!spectate,limit=1,sort=random,scores={playerID=0}] playerID 3
scoreboard players set @a[tag=!spectate,limit=1,sort=random,scores={playerID=0}] playerID 4
gamemode spectator @a[tag=spectate]

execute if entity @s[tag=singleplayer] run summon armor_stand 25 60 90 {CustomNameVisible:1,Pose:{RightArm:[-15f,0f,0f],Head:[45f,0f,0f],LeftArm:[0f,0f,0f]},NoGravity:1,CustomName:"\"AI\"",ShowArms:1,Tags:["player"],Rotation:[90f,45f],NoBasePlate:1,ArmorItems:[{id:"minecraft:leather_boots",Count:1b},{id:"minecraft:leather_leggings",Count:1b},{id:"minecraft:leather_chestplate",Count:1b},{id:"minecraft:player_head",Count:1b}]}
scoreboard players set @e[name=AI] playerID 2
execute if entity @s[tag=4player] unless entity @a[scores={playerID=4}] run summon armor_stand -30 61 -90 {CustomNameVisible:1,Pose:{RightArm:[-15f,0f,0f],Head:[45f,0f,0f],LeftArm:[0f,0f,0f]},NoGravity:1,CustomName:"\"AI\"",ShowArms:1,Tags:["player"],Rotation:[90f,45f],NoBasePlate:1,ArmorItems:[{id:"minecraft:leather_boots",Count:1b},{id:"minecraft:leather_leggings",Count:1b},{id:"minecraft:leather_chestplate",Count:1b},{id:"minecraft:player_head",Count:1b}]}
execute if entity @s[tag=4player] unless entity @a[scores={playerID=4}] run scoreboard players set @e[name=AI] playerID 4


tag @s add game

replaceitem entity @a hotbar.0 red_stained_glass_pane{drop:1b,display:{Name:"{\"text\":\"Red\",\"color\":\"red\",\"italic\":\"false\"}"}}
replaceitem entity @a hotbar.1 yellow_stained_glass_pane{drop:1b,display:{Name:"{\"text\":\"Yellow\",\"color\":\"yellow\",\"italic\":\"false\"}"}}
replaceitem entity @a hotbar.2 light_blue_stained_glass_pane{drop:1b,display:{Name:"{\"text\":\"Blue\",\"color\":\"aqua\",\"italic\":\"false\"}"}}
replaceitem entity @a hotbar.3 lime_stained_glass_pane{drop:1b,display:{Name:"{\"text\":\"Green\",\"color\":\"green\",\"italic\":\"false\"}"}}

# Bossbars
scoreboard players operation @e[tag=player] health = @e[name=game,limit=1] health
bossbar set p1 name [{"selector":"@e[scores={playerID=1},limit=1]","color":"aqua"},{"text":"'s Health"}]
bossbar set p2 name [{"selector":"@e[scores={playerID=2},limit=1]","color":"red"},{"text":"'s Health"}]
bossbar set p3 name [{"selector":"@e[scores={playerID=3},limit=1]","color":"green"},{"text":"'s Health"}]
bossbar set p4 name [{"selector":"@e[scores={playerID=4},limit=1]","color":"yellow"},{"text":"'s Health"}]
execute store result bossbar minecraft:p1 value run scoreboard players get @e[name=game,limit=1] health
execute store result bossbar minecraft:p2 value run scoreboard players get @e[name=game,limit=1] health
execute store result bossbar minecraft:p3 value run scoreboard players get @e[name=game,limit=1] health
execute store result bossbar minecraft:p4 value run scoreboard players get @e[name=game,limit=1] health
execute store result bossbar minecraft:p1 max run scoreboard players get @e[name=game,limit=1] health
execute store result bossbar minecraft:p2 max run scoreboard players get @e[name=game,limit=1] health
execute store result bossbar minecraft:p3 max run scoreboard players get @e[name=game,limit=1] health
execute store result bossbar minecraft:p4 max run scoreboard players get @e[name=game,limit=1] health
bossbar set p1 visible true
bossbar set p2 visible true
execute if entity @e[scores={playerID=3}] run bossbar set p3 visible true
execute if entity @e[scores={playerID=4}] run bossbar set p4 visible true
bossbar set p1 players @a
bossbar set p2 players @a
bossbar set p3 players @a
bossbar set p4 players @a

scoreboard players set @e[name=game] spawntimer 0

playsound entity.ender_dragon.growl master @a ~ ~ ~ 1000 1 1


execute unless entity @s[tag=4player] run tp @e[scores={playerID=1}] -25 60 90 -90 45
execute unless entity @s[tag=4player] run tp @e[scores={playerID=2}] 25 60 90 90 45

execute if entity @s[tag=4player] run tp @e[scores={playerID=1}] 0 61 -60 180 0
execute if entity @s[tag=4player] run tp @e[scores={playerID=2}] 0 61 -121 0 0
execute if entity @s[tag=4player] run tp @e[scores={playerID=3}] -30 61 -90 -90 0
execute if entity @s[tag=4player] run tp @e[scores={playerID=4}] 31 61 -90 90 0

scoreboard players set @s powerup 0
scoreboard players reset * powerups
scoreboard players reset @s rageTimer
tag @s remove rage1
tag @s remove rage2